Foxit PDF RDK

Public Member Functions | Static Public Attributes | List of all members
Renderer Class Reference
Inheritance diagram for Renderer:

## Public Member Functions
| constructor (bitmap, is_rgb_order)
| Constructor, with bitmap. More...
| EnableForPrint (is_render_for_print)
| Set the flag to decide whether to do rendering in print mode. More...
| IsEmpty ()
| Check whether current object is empty or not. More...
| RenderAnnot (annot, matrix)
| Render a specified annotation. More...
< boolean > | RenderFormControls (page, matrix)
| Render form controls. More...
| RenderGraphicsObject (graphics_object, page, matrix)
| Render a graphics object. More...
| SetClearType (is_clear_type)
| Set the flag to decide whether to use ClearType-like anti-aliasing to render text objects. More...
| SetClipPathFill (clip_path, matrix, fill_mode)
| Set clipping path using filled region. More...
| SetClipPathStroke (clip_path, matrix, graph_state)
| Set clipping path using stroked region. More...
| SetClipRect (clip_rect)
| Set the clipping rectangle which will be used in following rendering progress. More...
| SetColorMode (color_mode)
| Set color mode. More...
| SetForceDownSample (is_to_force_down_sample)
| Set the flag to decide whether to use down-sampling for image stretching. More...
| SetForceHalftone (is_to_force_halftone)
| Set the flag to decide whether to use halftone for image stretching. More...
| SetJPEGDownSample (is_jepg_down_sample)
| Set the flag to decide whether to use down-sampling for jpeg image. More...
| SetJPXDownSample (is_jpx_down_sample)
| Set the flag to decide whether to use down-sampling for jpx image. More...
| SetLayerContext (layer_context)
| Set layer context to render context handle. More...
| SetMappingModeColors (background_color, foreground_color)
| Set background color and foreground color when color mode is Renderer.e_ColorModeMappingGray or Renderer.e_ColorModeMapping. More...
| SetPrintTextAsGraphic (is_to_print_text_graphic)
| Set the flag to decide whether to print text as path or bitmap. More...
| SetPrintTextAsImage (is_to_print_text_image)
| Set the flag to decide whether to print text as image. More...
| SetRenderAnnotAppearanceType (ap_type)
| Set the annotation's appearance type for rendering. More...
| SetRenderAnnotsForThumbnail (is_render_annots_for_thumbnail)
| Set rendering flag to decide whether to render annotations in thumbnail mode or not. More...
| SetRenderBrightness (percent)
| Set the brightness percentages without affecting the black and white pixels. More...
| SetRenderContentFlags (render_content_flags)
| Set rendering flag to decide what content will be rendered. More...
| SetRenderEnhanceThinLines (is_render_enhance_thin_lines)
| Set the flag to decide whether to enhance thin lines. More...
| SetRenderFormField (is_render_formfield)
| Set the flag to decide whether to render form fields (except signature fields). More...
| SetRenderImageAntiAliasing (is_render_image_antialiasing)
| Set the flag to decide whether to draw image anti-aliasing. More...
| SetRenderInvertBlackWhite (is_render_invert_black_white)
| Set the flag to decide whether to invert black and white. More...
| SetRenderPathAntiAliasing (is_render_path_antialiasing)
| Set the flag to decide whether to draw path anti-aliasing. More...
| SetRenderPathFullCovered (is_render_path_full_covered)
| A special flag that can be applied to fill mode. More...
| SetRenderPathThinLine (is_render_path_thin_line)
| Set the flag to decide whether to draw path as thin line. More...
| SetRenderSignature (is_render_signature)
| Set the flag to decide whether to render signatures or not. More...
| SetRenderSignatureState (is_render_signature_state)
| Set the flag to decide whether to draw the signature state on the signature. More...
| SetRenderTextAntiAliasing (is_render_text_antialiasing)
| Set the flag to decide whether to draw text anti-aliasing. More...
| StartQuickRender (page, matrix, pause)
| Start to quickly render a PDF page, mainly for thumbnail purpose. More...
| StartRender (page, matrix, pause)
| Start to render a PDF page. More...
| StartRenderAsync (page, matrix, pause)
| Start to render a PDF page. More...
< Progressive > | StartRenderBitmap (bitmap, matrix, clip_rect, interpolation, pause)
| Start to render a bitmap. More...
< Progressive > | StartRenderReflowPage (reflow_page, matrix, pause)
| Start to render a reflow page. More...
| StartRenderXFAPage (xfa_page_view, matrix, is_highlight, pause)
| Start to render an XFA page. More...
Public Member Functions inherited from NativeObjectWrapper
| constructor (r)
| GetPointerAsNumber ()

## Static Public Attributes
static | e_ColorModeMapping
| Map a color value to the color range defined by a background color and a foreground color.
static | e_ColorModeMappingGray
| Map gray/white/black color value to background/foreground; for other colors, no change.
static | e_ColorModeNormal
| Enumeration for rendering color mode. More...
static | e_RenderAnnot
| If set, annotations will be rendered.
static | e_RenderPage
| Enumeration for rendering content flags. More...

## Detailed Description

PDF renderer is a graphics engine and is used to render page to a bitmap or a platform device context. This class can be constructed with a bitmap, or a device object. It offers functions to set rendering options/flags, and do rendering. In this class, there are several ways to do rendering:

- To render page and annotations, first use function Renderer.SetRenderContentFlags to decide whether to render page and annotation both or not, and then use functions Renderer.StartRender to do the rendering. Function Renderer.StartQuickRender can also be used to render page but only for thumbnail purpose.
- To render a single annotation, use function Renderer.RenderAnnot.
- To render a bitmap, use function Renderer.StartRenderBitmap.
- To render a reflow page, use function Renderer.StartRenderReflowPage.

Widget annotation is always associated with form field and form control in Foxit PDF SDK. For how to render widget annotations, here is a recommended flow:

- After loading a PDF page, first render the page and all annotations in this page (including widget annotations).
- Then, if user uses Filler object to fill the form, user should use function Filler.Render to render the focused form control instead of using function Renderer.RenderAnnot.

See also
  Filler

Examples
  /Users/ec2-user/gitlab-runner/builds/E-xKdhDo/0/foxit/sdk/mobile/gsdk-doc-auto-build/harmony_nodejs/input/Index.js.

## Member Function Documentation

## ◆ constructor()

Renderer.constructor | ( | bitmap | ,
|  | is_rgb_order |
| ) |  |

Constructor, with bitmap.

The input bitmap is treated as an independent device and all the content rendered by the renderer would appear in the bitmap.

Parameters

  [in] | bitmap | A bitmap used for rendering. User should ensure the bitmap to keep valid until the end of life cycle of current renderer object. The format of bitmap should not be Bitmap.e_DIB1bpp.
  [in] | is_rgb_order | true means Foxit PDF SDK needs to use RGB byte-order (Red is in the lowest order) when rendering. false means Foxit PDF SDK needs to use BGR byte-order (Blue is in the lowest order) when rendering.

## ◆ EnableForPrint()

Renderer.EnableForPrint | ( | is_render_for_print |  | ) |

Set the flag to decide whether to do rendering in print mode.

Please ensure this rendering flag is set as expected when current renderer is to used for printing. For rendering annotations, if this flag is set to be true, Foxit PDF SDK will only render annotations which have annotation flag Annot.e_FlagPrint.
If this function is not called for current renderer object yet, default value false will be used.

Parameters

  [in] | is_render_for_print | true means to render in print mode, while false means to render not in print mode.

Returns
  None.

## ◆ IsEmpty()

Renderer.IsEmpty | ( |  | ) |

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  true means current object is empty, while false means not.

## ◆ RenderAnnot()

Renderer.RenderAnnot | ( | annot | ,
|  | matrix |
| ) |  |

Render a specified annotation.

When this function is called, rendering flag (set by function Renderer.SetRenderContentFlags or by default) will be ignored.

Parameters

  [in] | annot | An annotation object to be rendered. If input annot is a pop-up annotation, this function will not render it and will return false.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function PDFPage.GetDisplayMatrix.

Returns
  true means success, while false means failure.

## ◆ RenderFormControls()

<boolean> Renderer.RenderFormControls | ( | page | ,
|  | matrix |
| ) |  |

Render form controls.

When this function is called, rendering flag (set by function Renderer.SetRenderContentFlags or by default) will be ignored.

Parameters

  [in] | page | A valid PDF page. If input page is invalid, this function do nothing and return false directly.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function PDFPage.GetDisplayMatrix.

Returns
  true means success, while false means failure.

## ◆ RenderGraphicsObject()

Renderer.RenderGraphicsObject | ( | graphics_object | ,
|  | page | ,
|  | matrix |
| ) |  |

Render a graphics object.

When this function is called, rendering flag (set by function Renderer.SetRenderContentFlags or by default) will be ignored.

Parameters

  [in] | graphics_object | A valid PDF graphics object to be rendered.
  [in] | page | A valid PDF page. Parameter graphics_object belongs to this PDF page.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function PDFPage.GetDisplayMatrix.

Returns
  true means success, while false means failure.

## ◆ SetClearType()

Renderer.SetClearType | ( | is_clear_type |  | ) |

Set the flag to decide whether to use ClearType-like anti-aliasing to render text objects.

If this function is not called, default value true will be used.

Parameters

  [in] | is_clear_type | true means to use ClearType-like anti-aliasing to render text objects. false means not to use ClearType-like anti-aliasing to render text objects.

Returns
  None.

## ◆ SetClipPathFill()

Renderer.SetClipPathFill | ( | clip_path | ,
|  | matrix | ,
|  | fill_mode |
| ) |  |

Set clipping path using filled region.

Parameters

  [in] | clip_path | A clipping path.
  [in] | matrix | The transformation matrix used for clipping.
  [in] | fill_mode | Fill mode. It should be value e_FillModeAlternate or e_FillModeWinding.

Returns
  None.

## ◆ SetClipPathStroke()

Renderer.SetClipPathStroke | ( | clip_path | ,
|  | matrix | ,
|  | graph_state |
| ) |  |

Set clipping path using stroked region.

Parameters

  [in] | clip_path | A clipping path.
  [in] | matrix | The transformation matrix used for clipping.
  [in] | graph_state | A valid graph state, for pen attributes. If this is null, Foxit PDF SDK will use a graph state object with default constructor. Default value: null.

Returns
  None.

## ◆ SetClipRect()

Renderer.SetClipRect | ( | clip_rect |  | ) |

Set the clipping rectangle which will be used in following rendering progress.

Parameters

  [in] | clip_rect | A clipping rectangle. If it is null, that means not to use clipping rectangle in following rendering progress.

Returns
  None.

## ◆ SetColorMode()

Renderer.SetColorMode | ( | color_mode |  | ) |

Set color mode.

If this function is not called, default value Renderer.e_ColorModeNormal will be used.

Parameters

  [in] | color_mode | Color mode value. It should be one of following values: Renderer.e_ColorModeNormal means normal color mode. Renderer.e_ColorModeMappingGray means to map white/black color value to background/foreground; for other colors, no change. If this mode is used, please call function Renderer.SetMappingModeColors to set "background color" and "foreground color". Renderer.e_ColorModeMapping means to map a color value to the color range defined by a background color and a foreground color. If this mode is used, please call function Renderer.SetMappingModeColors to set "background color" and "foreground color".

Returns
  None.

## ◆ SetForceDownSample()

Renderer.SetForceDownSample | ( | is_to_force_down_sample |  | ) |

Set the flag to decide whether to use down-sampling for image stretching.

If this function is not called, default value false will be used.

Parameters

  [in] | is_to_force_down_sample | true means to use down-sampling for image stretching. false means not to use down-sampling for image stretching.

Returns
  None.

## ◆ SetForceHalftone()

Renderer.SetForceHalftone | ( | is_to_force_halftone |  | ) |

Set the flag to decide whether to use halftone for image stretching.

If this function is not called, default value false will be used.

Parameters

  [in] | is_to_force_halftone | true means to use halftone for image stretching. false means not to use halftone for image stretching.

Returns
  None.

## ◆ SetJPEGDownSample()

Renderer.SetJPEGDownSample | ( | is_jepg_down_sample |  | ) |

Set the flag to decide whether to use down-sampling for jpeg image.

Whether to use down-sampling for jpeg image or not will affect rendering result for a PDF page. When current function is called successfully, user should called function PDFPage.ClearRenderCache for a PDF page (which has been rendered at least once) before rendering the PDF page again.
If this function is not called, default value true will be used.

Parameters

  [in] | is_jepg_down_sample | true means to use down-sampling for jpeg image. false means not to use down-sampling for jpeg image.

Returns
  None.

## ◆ SetJPXDownSample()

Renderer.SetJPXDownSample | ( | is_jpx_down_sample |  | ) |

Set the flag to decide whether to use down-sampling for jpx image.

Whether to use down-sampling for jpx image or not will affect rendering result for a PDF page. When current function is called successfully, user should called function PDFPage.ClearRenderCache for a PDF page (which has been rendered at least once) before rendering the PDF page again.
If this function is not called, default value true will be used.

Parameters

  [in] | is_jpx_down_sample | true means to use down-sampling for jpx image. false means not to use down-sampling for jpx image.

Returns
  None.

## ◆ SetLayerContext()

Renderer.SetLayerContext | ( | layer_context |  | ) |

Set layer context to render context handle.

In order to render one layer when PDF page's contents is rendered on a rendering context, user should call this function to set the layer context to render context.

Parameters

  [in] | layer_context | A layer context object.

Returns
  None.

## ◆ SetMappingModeColors()

Renderer.SetMappingModeColors | ( | background_color | ,
|  | foreground_color |
| ) |  |

Set background color and foreground color when color mode is Renderer.e_ColorModeMappingGray or Renderer.e_ColorModeMapping.

Parameters

  [in] | background_color | The background color. Format: 0xAARRGGBB.
  [in] | foreground_color | The foreground color. Format: 0xAARRGGBB.

Returns
  None.

## ◆ SetPrintTextAsGraphic()

Renderer.SetPrintTextAsGraphic | ( | is_to_print_text_graphic |  | ) |

Set the flag to decide whether to print text as path or bitmap.

When this flag is true, Foxit PDF SDK will render text in different way: if font size is greater than 50, print text as path; otherwise, print text as bitmap.
If this function is not called, default value false will be used.

Parameters

  [in] | is_to_print_text_graphic | true means to print text as path or bitmap. false means not to print text as path or bitmap.

Returns
  None.

## ◆ SetPrintTextAsImage()

Renderer.SetPrintTextAsImage | ( | is_to_print_text_image |  | ) |

Set the flag to decide whether to print text as image.

If this function is not called, default value false will be used.

Parameters

  [in] | is_to_print_text_image | true means to print text as image. false means not to print text as image.

Returns
  None.

## ◆ SetRenderAnnotAppearanceType()

Renderer.SetRenderAnnotAppearanceType | ( | ap_type |  | ) |

Set the annotation's appearance type for rendering.

Parameters

  [in] | ap_type | Type of annotation's appearance. Please refer to values starting from Annot.e_AppearanceTypeNormal and this should be one of these values.

Returns
  None.

## ◆ SetRenderAnnotsForThumbnail()

Renderer.SetRenderAnnotsForThumbnail | ( | is_render_annots_for_thumbnail |  | ) |

Set rendering flag to decide whether to render annotations in thumbnail mode or not.

In thumbnail mode, the flags of annotations, "NoZoom" and "NoRotate", will be ignored. This rendering flag is available only when flag Renderer.e_RenderAnnot is used for rendering or function Renderer.RenderAnnot is called. Please refer to function Renderer.SetRenderContentFlags about setting flag Renderer.e_RenderAnnot.
If this function is not called, default value false will be used when this rendering flag is available.

Parameters

  [in] | is_render_annots_for_thumbnail | true means to render annotations in thumbnail mode. false means not to render annotations in thumbnail mode.

Returns
  None.

## ◆ SetRenderBrightness()

Renderer.SetRenderBrightness | ( | percent |  | ) |

Set the brightness percentages without affecting the black and white pixels.

Parameters

  [in] | percent | Brightness in percents. Valid range: from 0 to 100. The default value is 100.

## ◆ SetRenderContentFlags()

Renderer.SetRenderContentFlags | ( | render_content_flags |  | ) |

Set rendering flag to decide what content will be rendered.

If this function is not called, default value (Renderer.e_RenderPage | Renderer.e_RenderAnnot) will be used.

Parameters

  [in] | render_content_flags | Rendering content flags. Please refer to values starting from Renderer.e_RenderPage and this should be one or a combination of these values.

Returns
  None.

## ◆ SetRenderEnhanceThinLines()

Renderer.SetRenderEnhanceThinLines | ( | is_render_enhance_thin_lines |  | ) |

Set the flag to decide whether to enhance thin lines.

If this function is not called, default value false will be used.

Parameters

  [in] | is_render_enhance_thin_lines | true means to draw zero width lines with a thicker path so they are more visible than the default single pixel. false means to draw zero width lines with a single pixel width.

Returns
  None.

## ◆ SetRenderFormField()

Renderer.SetRenderFormField | ( | is_render_formfield |  | ) |

Set the flag to decide whether to render form fields (except signature fields).

If this function is not called, default value true will be used when this flag is available.

Parameters

  [in] | is_render_formfield | true means to render form fields (except signature fields). false means not to render form fields (except signature fields).

Returns
  None.

## ◆ SetRenderImageAntiAliasing()

Renderer.SetRenderImageAntiAliasing | ( | is_render_image_antialiasing |  | ) |

Set the flag to decide whether to draw image anti-aliasing.

If this function is not called, default value true will be used.

Parameters

  [in] | is_render_image_antialiasing | true means to draw image anti-aliasing, and the effect would be similar to values defined in enum class InterpolationFlag. false means to draw image aliasing.

Returns
  None.

## ◆ SetRenderInvertBlackWhite()

Renderer.SetRenderInvertBlackWhite | ( | is_render_invert_black_white |  | ) |

Set the flag to decide whether to invert black and white.

If this function is not called, default value false will be used. If this flag is set to be true, it will invert black and white pixels.

Parameters

  [in] | is_render_invert_black_white | true means to invert black and white pixels, while false means not.

## ◆ SetRenderPathAntiAliasing()

Renderer.SetRenderPathAntiAliasing | ( | is_render_path_antialiasing |  | ) |

Set the flag to decide whether to draw path anti-aliasing.

If this function is not called, default value true will be used.

Parameters

  [in] | is_render_path_antialiasing | true means to draw path anti-aliasing. false means to draw path aliasing.

Returns
  None.

## ◆ SetRenderPathFullCovered()

Renderer.SetRenderPathFullCovered | ( | is_render_path_full_covered |  | ) |

A special flag that can be applied to fill mode.

If this function is not called, default value false will be used.

Parameters

  [in] | is_render_path_full_covered | true means that all pixels partially covered by the path will be fully painted, while false means not.

Returns
  None.

## ◆ SetRenderPathThinLine()

Renderer.SetRenderPathThinLine | ( | is_render_path_thin_line |  | ) |

Set the flag to decide whether to draw path as thin line.

If this function is not called, default value false will be used.

Parameters

  [in] | is_render_path_thin_line | true means to draw path as thin line. false means not to draw path as thin line.

Returns
  None.

## ◆ SetRenderSignature()

Renderer.SetRenderSignature | ( | is_render_signature |  | ) |

Set the flag to decide whether to render signatures or not.

If this function is not called, default value true will be used when this flag is available.

Parameters

  [in] | is_render_signature | true means to render signatures. false means not to render signatures.

Returns
  None.

## ◆ SetRenderSignatureState()

Renderer.SetRenderSignatureState | ( | is_render_signature_state |  | ) |

Set the flag to decide whether to draw the signature state on the signature.

If this function is not called, default value true will be used.

Parameters

  [in] | is_render_signature_state | true means to draw the signature state on the signature, while false means not.

## ◆ SetRenderTextAntiAliasing()

Renderer.SetRenderTextAntiAliasing | ( | is_render_text_antialiasing |  | ) |

Set the flag to decide whether to draw text anti-aliasing.

If this function is not called, default value true will be used.

Parameters

  [in] | is_render_text_antialiasing | true means to draw text anti-aliasing. false means to draw text aliasing.

Returns
  None.

## ◆ StartQuickRender()

Renderer.StartQuickRender | ( | page | ,
|  | matrix | ,
|  | pause |
| ) |  |

Start to quickly render a PDF page, mainly for thumbnail purpose.

This function is mainly used for render a page for thumbnail purpose. The rendered content will not be completed: all the annotations will be ignored, event if flag Renderer.e_RenderAnnot is set by function Renderer.SetRenderContentFlags; text content will become blurred and will be replace by pixel point.
It may still take a long time to do this quick rendering when page has complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | page | A valid PDF page. It should have been parsed.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function PDFPage.GetDisplayMatrix.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartRender()

Renderer.StartRender | ( | page | ,
|  | matrix | ,
|  | pause |
| ) |  |

Start to render a PDF page.

It may take a long time to render a PDF page with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.
Widget annotation is always associated with form field and form control in Foxit PDF SDK. For how to render widget annotations, here is a recommended flow:

- After loading a PDF page, first render the page and all annotations in this page (including widget annotations).
- Then, if user uses Filler object to fill the form, user should use function Filler.Render to render the focused form control instead of using function Renderer.RenderAnnot.

Parameters

  [in] | page | A valid PDF page. If only to render annotations (that means only Renderer.e_RenderAnnot is set by function Renderer.SetRenderContentFlags), there is no need to parse the input page; otherwise the input page should have been parsed.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function PDFPage.GetDisplayMatrix.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartRenderAsync()

Renderer.StartRenderAsync | ( | page | ,
|  | matrix | ,
|  | pause |
| ) |  |

Start to render a PDF page.

It may take a long time to render a PDF page with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.
Widget annotation is always associated with form field and form control in Foxit PDF SDK. For how to render widget annotations, here is a recommended flow:

- After loading a PDF page, first render the page and all annotations in this page (including widget annotations).
- Then, if user uses Filler object to fill the form, user should use function Filler.Render to render the focused form control instead of using function Renderer.RenderAnnot.

Parameters

  [in] | page | A valid PDF page. If only to render annotations (that means only Renderer.e_RenderAnnot is set by function Renderer.SetRenderContentFlags), there is no need to parse the input page; otherwise the input page should have been parsed.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function PDFPage.GetDisplayMatrix.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartRenderBitmap()

<Progressive> Renderer.StartRenderBitmap | ( | bitmap | ,
|  | matrix | ,
|  | clip_rect | ,
|  | interpolation | ,
|  | pause |
| ) |  |

Start to render a bitmap.

It may take a long time to render a bitmap with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | bitmap | A valid bitmap. User should ensure the bitmap to keep valid until current rendering process is finished.
  [in] | matrix | The transformation matrix used for rendering. This matrix is used as image matrix: assume that h is image height, w is image width, and then matrix [w 0 0 h 0 0] will produce an identical image.
  [in] | clip_rect | Clip rectangle for the rendering device. This can be null. Default value: null.
  [in] | interpolation | Bitmap interpolation flags. Please refer to values starting from Bitmap.e_Downsample and this can be one or a combination of these values. If not specify any flag, please use 0. Default value: 0.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartRenderReflowPage()

<Progressive> Renderer.StartRenderReflowPage | ( | reflow_page | ,
|  | matrix | ,
|  | pause |
| ) |  |

Start to render a reflow page.

It may take a long time to render a reflow page with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | reflow_page | A valid reflow page. It should have been parsed.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function ReflowPage.GetDisplayMatrix.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value:null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## ◆ StartRenderXFAPage()

Renderer.StartRenderXFAPage | ( | xfa_page_view | ,
|  | matrix | ,
|  | is_highlight | ,
|  | pause |
| ) |  |

Start to render an XFA page.

It will take a long time to render an XFA page with complex or large contents, so Foxit PDF SDK uses a progressive process to do this.

Parameters

  [in] | xfa_page_view | A valid XFA page.
  [in] | matrix | The transformation matrix used for rendering, which is usually returned by function XFAPage.GetDisplayMatrix.
  [in] | is_highlight | true means to highlight XFA widgets, and false means not to highlight XFA widgets.
  [in] | pause | Pause callback object which decides if the rendering process needs to be paused. This can be null which means not to pause during the rendering process. If this is not null, it should be a valid pause object implemented by user. Default value: null.

Returns
  A progressive object. Please check the rate of current progress by function Progressive.GetRateOfProgress. If the rate is not 100 yet, call function Progressive.Continue to continue the progress until the progress is finished.

## Member Data Documentation

## ◆ e_ColorModeNormal

Renderer.e_ColorModeNormal
| static

Enumeration for rendering color mode.

Values of this enumeration should be used alone.

Normal color mode.

## ◆ e_RenderPage

Renderer.e_RenderPage
| static

Enumeration for rendering content flags.

Values of this enumeration can be used alone or in combination.

If set, page content will be rendered.